Subject: Re: [BUG] NULL pointer dereference in skb_dequeue

From: Jarek Poplawski <[email-masked]>
Date: Tue, 12 Aug 2008 20:09:27 +0200

On Tue, Aug 12, 2008 at 06:42:24AM -0700, Paul E. McKenney wrote:
> On Tue, Aug 12, 2008 at 06:36:22AM +0000, Jarek Poplawski wrote:
...
> > >From net/sched/sch_generic.c:
> > 
> > void __qdisc_run(struct Qdisc *q)
> > {
> >         unsigned long start_time = jiffies;
> > 
> >         while (qdisc_restart(q)) {
> >                 /*
> >                  * Postpone processing if
> >                  * 1. another process needs the CPU;
> >                  * 2. we've been doing it for too long.
> >                  */
> >                 if (need_resched() || jiffies != start_time) {
> >                         __netif_schedule(q);
> > 
> > This function is run from dev_queue_xmit() (net/core/dev.c) under
> > rcu_read_lock_bh(), and this "q" pointer is passed here for later use
> > (reading) by softirq run net_tx_action(). Alas in net/ RCU primitives
> > are probably omitted in a few places...
> 
> If I understand this code, one way to handle it would be to increment
> q->refcnt before passing to netif_schedule(), then decrementing it
> (within an RCU read-side critical section) in the softirq handler.
> 
> There are probably other ways to handle this as well.

I understand this similarly (but I'm still trying to find out what's
wrong with reading this again in a separate read-side section).

David gave some additional explanations (which BTW don't look to me
like very "orthodox" RCU) in this thread:
http://marc.info/?l=linux-netdev&m=121851847805942&w=2

Thanks,
Jarek P.